#!/usr/bin/python

import sys
sys.path.append('../debsources/python')

import os
import sqlalchemy

import mainlib
import statistics

from consts import SLOCCOUNT_LANGUAGES


dburi = sys.argv[1]
db = sqlalchemy.create_engine(dburi)
Session = sqlalchemy.orm.sessionmaker()
session = Session(bind=db)

suites = statistics.suites(session, 'all')
areas = ['main']

def store_sloccount_stats(summary, d, prefix):
    """adapted from updater.py:update_statistics()"""
    total_slocs = 0
    for lang in SLOCCOUNT_LANGUAGES:
        k = prefix + '.' +  lang
        v = 0
        if summary.has_key(lang):
            v = summary[lang]
        d[k] = v
        total_slocs += v
    d[prefix] = total_slocs


stats = {}

# compute overall stats
suite = 'ALL'
for stat in ['disk_usage', 'source_packages', 'source_files', 'ctags']:
    v = getattr(statistics, stat)(session, areas=areas)
    stats['total.' + stat] = v
store_sloccount_stats(statistics.sloccount_summary(session, areas=areas),
                      stats, 'total.sloccount')

# compute per-suite stats
for suite in suites:
    suite_key = 'debian_' + suite + '.'
    for stat in ['disk_usage', 'source_packages', 'source_files', 'ctags']:
        v = getattr(statistics, stat)(session, suite, areas=areas)
        stats[suite_key + stat] = v
    store_sloccount_stats(statistics.sloccount_summary(session, suite, areas=areas),
                          stats, suite_key + 'sloccount')


statistics.save_metadata_cache(stats, 'stats-main.data')

# creates: ./stats-main.data
