SUITES_FILE = 'suites.data'
SUITES_FILE = "suites.data"
RELEASE_DUR_FILE = "release-duration.data"

from datetime import datetime, timedelta

def get_suites():
    suites = []
    with open(SUITES_FILE) as f:
        for line in f:
            suite = None
            release_date = None
            try:
                suite, release_date = line.split()
            except ValueError:
                suite = line.strip()
            suites.append((suite, release_date))
    return suites

def correct_suite_name(suite):
    if suite in ("jessie", "sid"):
        return suite + "*"
    else:
        return suite

def parse_date(string):
    return datetime.strptime(string, "%Y-%m-%d").date()

def next_release_date(last_release="wheezy"):
    with open(SUITES_FILE) as f:
        for line in f:
            if line[:len(last_release)] == last_release:
                date = parse_date(line.split()[1])
    with open(RELEASE_DUR_FILE) as f:
        for line in f:
            if line[:3] == "avg":
                return date + timedelta(days=int(float(line.split()[1])))

def split_suite(suite):
    suite = suite.strip().split()
    if len(suite) == 2:
        return dict(name=suite[0], date=parse_date(suite[1]))
    elif len(suite) == 1:
        suite = suite[0]
        if suite == "jessie":
            return dict(name=suite, date=next_release_date())
        else:
            raise Exception("unknow suite without release date")
    else:
        raise Exception("wrong suite format")
