-- example: hamm -> potato

CREATE OR REPLACE FUNCTION upstream_version (text) RETURNS text
  AS $$ SELECT regexp_replace($1, '-[^-]+$', ''); $$
  LANGUAGE SQL;


-- unchanged packages
SELECT COUNT(*) FROM
(
  (SELECT package_names.name, upstream_version(packages.version)
   FROM suites, packages, package_names
   WHERE suites.package_id = packages.id
   AND packages.name_id = package_names.id
   AND suites.suite = 'hamm')
  INTERSECT
  (SELECT package_names.name, upstream_version(packages.version)
   FROM suites, packages, package_names
   WHERE suites.package_id = packages.id
   AND packages.name_id = package_names.id
   AND suites.suite = 'potato')
) S;
--  count 
-- -------
--    463
-- (1 row)


-- common packages  (in hamm -> in potato)
SELECT COUNT(*) FROM
(
  (SELECT package_names.name
   FROM suites, packages, package_names
   WHERE suites.package_id = packages.id
   AND packages.name_id = package_names.id
   AND suites.suite = 'hamm')
  INTERSECT
  (SELECT package_names.name
   FROM suites, packages, package_names
   WHERE suites.package_id = packages.id
   AND packages.name_id = package_names.id
   AND suites.suite = 'potato')
) S;
--  count 
-- -------
--   1198
-- (1 row)


-- new packages     (not in hamm -> in potato)
SELECT COUNT(*) FROM
(
  (SELECT package_names.name
   FROM suites, packages, package_names
   WHERE suites.package_id = packages.id
   AND packages.name_id = package_names.id
   AND suites.suite = 'potato')
  EXCEPT
  (SELECT package_names.name
   FROM suites, packages, package_names
   WHERE suites.package_id = packages.id
   AND packages.name_id = package_names.id
   AND suites.suite = 'hamm')
) S;
--  count 
-- -------
--   1764
-- (1 row)


-- removed packages (in hamm -> not in potato)
SELECT COUNT(*) FROM
(
  (SELECT package_names.name
   FROM suites, packages, package_names
   WHERE suites.package_id = packages.id
   AND packages.name_id = package_names.id
   AND suites.suite = 'hamm')
  EXCEPT
  (SELECT package_names.name
   FROM suites, packages, package_names
   WHERE suites.package_id = packages.id
   AND packages.name_id = package_names.id
   AND suites.suite = 'potato')
) S;
--  count 
-- -------
--    174
-- (1 row)
