#!/usr/bin/env python

DATA_FILE = "stats.data"
OUTPUT_FILE = "package-average-size.csv"

import sys
sys.path.append('../debsources/python')

import csv
from debsources_data import get_suites
from app.extract_stats import extract_stats

def get_data():
    return extract_stats(filename=DATA_FILE)

def compute(data, output):
    with open(output, "w") as f:
        w = csv.writer(f, quoting=csv.QUOTE_ALL)
        w.writerow(["suite", "average SLOC per package"])
        
        for suite in get_suites():
            suite = suite[0]
            pkgs = data["debian_" + suite + ".source_packages"]
            sloc = data["debian_" + suite + ".sloccount"]
            w.writerow([suite, sloc / pkgs])



if __name__ == "__main__":
    data = get_data()
    compute(data, OUTPUT_FILE)
