#!/usr/bin/env python

SQL_DATA = "packages-files-difference.data"
OUTPUT_FILE = "packages-files-difference-average.csv"

import csv

def compute(sql_data, output_file):
    data = dict()
    
    with open(sql_data) as f:
        for line in f:
            if line.strip() == "":
                continue
            values = line.split('|')
            values = [v.strip() for v in values]

            suite_from_to = values[2] + "-" + values[4]
            len1 = int(values[5])
            inter = int(values[7])
            
            ratio = (float((len1 - inter)) / len1) * 100
            
            try:
                data[suite_from_to]
            except KeyError:
                data[suite_from_to] = [0, 0]
            
            data[suite_from_to][0] += ratio
            data[suite_from_to][1] += 1
    
    with open(output_file, "w") as f:
        w = csv.writer(f, quoting=csv.QUOTE_ALL)
        w.writerow(["from_to", "ratio"])
        for s in data.keys():
            w.writerow([s, data[s][0] / data[s][1]])

if __name__ == "__main__":
    compute(SQL_DATA, OUTPUT_FILE)
