#!/usr/bin/python
import numpy
import sys

from datetime import datetime

from debsources_data import get_suites

DATE_FMT = '%Y-%m-%d'

release_durations = []
last_release_date = None

for (release_name, release_date) in get_suites():
    if not release_date:
        continue
    release_date = datetime.strptime(release_date, DATE_FMT)
    if last_release_date is not None:
        release_duration = abs(release_date - last_release_date).days
        release_durations.append(release_duration)
        print '%s\t%d' % (release_name, release_duration)
    last_release_date = release_date

print
print 'avg\t%f' % numpy.mean(release_durations)
print 'var\t%f' % numpy.var(release_durations)
print 'std\t%f' % numpy.std(release_durations)
