#!/usr/bin/python

DATA_FILE = 'sloc-freq-%s.data'

import sys
sys.path.append('../debsources/python')

import os
import sqlalchemy

import statistics

from debsources_data import get_suites

dburi = sys.argv[1]
db = sqlalchemy.create_engine(dburi)
Session = sqlalchemy.orm.sessionmaker()
session = Session(bind=db)

def compute_freq(suite=None):
    slocs = statistics.sloc_per_package(session, suite=suite)	# name, version, sloc

    suite_name = suite
    if suite is None:
        suite_name = 'all'

    with open(DATA_FILE % suite_name, 'w') as data:
        for name, version, sloc in slocs:
            data.write('%s/%s\t%d\n' % (name, version, sloc))

for suite, _reldate in get_suites():
    compute_freq(suite)
compute_freq()
