#!/usr/bin/python

import sys
sys.path.append('../debsources/python')

import csv
import string

import statistics

COMMA = ','
METRICS = [
    # metric key, table label
    ('source_packages', 'pkgs', lambda x: '{0:,}'.format(int(x)), '%s'),
    ('source_files', 'files(k)', lambda x: float(x) / 1000, '%.1f'),
    ('disk_usage', 'du(GB)', lambda x: float(x) / 1048576, '%.1f'),
    ('sloccount', 'sloc(G)', lambda x: float(x) / 1000000, '%.1f'),
    ('ctags', 'ctags(M)', lambda x: float(x) / 1000000, '%.1f'),
]

stats = statistics.load_metadata_cache(sys.argv[1])

avg_size = {}
with open('package-average-size.csv') as csvfile:
    reader = csv.reader(csvfile)
    for line in reader:
        if line[0] == 'suite':
            continue	# skip header
        avg_size[line[0]] = int(line[1])

sys.stdout.write(string.join(['release'] + map(lambda p: p[1], METRICS), COMMA))
print COMMA + 'mean pkg size (kSLOC)'

for line in open('suites.data'):
    fields = []
    suite = line.split()[0]
    reldate = None
    try:
        reldate = line.split()[1]
    except IndexError:
        pass
    ext = ""
    if reldate is None:
        ext = "*"
    fields.append(suite + ext)
    for (key, _label, render, fmt) in METRICS:
        fields.append(('"' + fmt + '"') % render(stats['debian_%s.%s' % (suite, key)]))
    sys.stdout.write(string.join(fields, COMMA))
    print COMMA + '%.1f' % (float(avg_size[suite]) / 1000)
        
